#
# Browse.pl
#
# This script demonstrates how to get all object in a context from NDS
# with the perl extension PerlWare.
#
# Copyright (c) 1997 Steinar Kleven
#



use PerlWare::NDSContext;
use PerlWare::Buf_T;

sub Mydie {
	$ErrMsg = shift;
	open LOG, ">>rattrib.err";
	print LOG $ErrMsg;
   print $ErrMsg;
   exit(-1);
}


sub GetErrAndDie {
	$Text = shift;
 	$Class = shift;
   Mydie($Text . ",error : ". $Class->LastErr());
}


$C = new PerlWare::NDSContext;

$CHandle = $C->GetHandle();

# buffer for reply
$OutBuf = new PerlWare::Buf_T;
Mydie("Error creating all classes.\n") if (!($C && $OutBuf));


# We can't do anything if we're not logged on
if(!$C->IsDSAuthenticated())
{
	print "Type username: ";
	chomp($UserName = <STDIN>);
   print "Password: ";
   chomp($Passwd = <STDIN>);
   $C->Login(0, $UserName, Passwd, 0);
}


# Alloc Result-buffer.
$Result = $OutBuf->AllocBuf();
GetErrAndDie("Could not allocate buffer", $OutBuf) if $Result;

print "Type the context you want to list : ";
$Context = <STDIN>;
chomp($Context);

$Result = $C->SetContext("DCK_NAME_CONTEXT", $Context);
GetErrAndDie("Could not set context", $C) if $Result;

$iter = $OutBuf->GetConst("NO_MORE_ITERATIONS");
do
{
  $iter = $OutBuf->List($CHandle, $Context, $iter);
  GetErrAndDie("Error retrieving objects", $OutBuf) if (!defined($iter));
  $ObjectCount = $OutBuf->GetObjectCount($CHandle);
  GetErrAndDie("Could not get object count", $OutBuf) if (!defined($ObjectCount));

  #Now we can list all objects in this context
  $ok = 1;
  for($i=0; $i < $ObjectCount; $i++) {
    ($ObjectName) = $OutBuf->GetObjectName($CHandle);
    GetErrAndDie("Could not get object name", $OutBuf) if (!defined($ObjectName));
    print "$i: $ObjectName\n";
  }
}while ($ok && $iter != -1);

print "All methods passed\n";
__EN